#import "GameSocketSocket.h"
#import "GameSocketEvent.h"

@class GameSocket;

@protocol GameSocketDelegate <NSObject>
@optional
- (void) didReceiveEvent:(GameSocketEvent*)event;
@end

@interface GameSocket : NSObject <GameSocketSocketDelegate>

@property (strong, nonatomic) NSString *uuid;
@property (nonatomic) NSString *serverEndpoint;
@property (assign) uint16_t serverPort;
@property (assign) uint16_t port;
@property (weak, nonatomic) id <GameSocketDelegate> delegate;

- (BOOL) start;
- (BOOL) stop;
- (void) sendEvent:(GameSocketEvent*)event;

@end