#import "AppDelegate.h"

// CocoaLumberjack
#import "DDLog.h"
#import "DDTTYLogger.h"

const int ddLogLevel = LOG_LEVEL_VERBOSE;

@implementation AppDelegate

@synthesize window, portField, actualPortField, serverEndpointField, serverPortField, updateButton, eventKindField, eventDataField, gameSocket;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
  [DDLog addLogger:[DDTTYLogger sharedInstance]];
  DDLogVerbose(@"Application started.");
}

- (GameSocket*) gameSocket {
  if (gameSocket) return gameSocket;
  DDLogVerbose(@"Initializing GameSocket...");
  gameSocket = [GameSocket new];
  gameSocket.delegate = self;
  return gameSocket;
}

- (IBAction) update:sender {
  self.gameSocket.port = [self.portField integerValue];
  DDLogVerbose(@"Going to start Socket...");
  [self.gameSocket start];
}

- (IBAction) stop:sender {
  DDLogVerbose(@"Going to stop Socket...");
  [self.gameSocket stop];
}

- (IBAction) send:sender {
  self.gameSocket.serverEndpoint = [self.serverEndpointField stringValue];
  self.gameSocket.serverPort = [self.serverPortField integerValue];
  GameSocketEvent *event = [GameSocketEvent eventOfKind:[self.eventKindField stringValue] andData:[self.eventDataField stringValue]];
  [self.gameSocket sendEvent:event];
}

/*** GameSocket Delegation ***/

- (void) didReceiveEvent:(GameSocketEvent*)event {
  DDLogVerbose(@"Received Event...");
}

@end
